<template>
  <page>
    <a-form
      class="notificacao-form"
      @submit="handleSubmit"
    >
      <h1>Preencha os dados do parceiro</h1>
      <a-form-item
        label="Nome do parceiro"
        class="input-icon"
        required="true"
      >
        <a-input
          v-model="title"
          placeholder="Digite o nome do parceiro"
          type="text"
          maxlength="25"
          required="true"
        />
      </a-form-item>

      <a-form-item
        label="Link da página do parceiro"
        class="input-icon"
      >
        <a-input
          v-model="link"
          placeholder="Digite o link para a página do parceiro"
          type="url"
          pattern="https://.*"
        />
      </a-form-item>

      <a-form-item
        label="Logotipo do parceiro"
        class="input-icon"
        required="true"
      >
        <a-upload-dragger
          :file-list="fileList"
          :remove="handleRemove"
          :before-upload="beforeUpload"
        >
          <p class="ant-upload-drag-icon">
            <a-icon type="inbox" />
          </p>
          <p class="ant-upload-text">
            Clique ou arraste a foto para essa área
          </p>
        </a-upload-dragger>
      </a-form-item>

      <a-form-item>
        <a-button
          html-type="submit"
          type="primary"
          class="submit-button"
          :disabled="uploading"
        >
          <span v-if="uploading">
            <a-icon type="loading" />
          </span>
          <span v-else>Enviar</span>
        </a-button>
      </a-form-item>
    </a-form>
  </page>
</template>

<script>
import uploadDragger from '@/mixins/upload-dragger';

export default {
  name: 'AddPartner',
  mixins: [uploadDragger],
  data() {
    return {
      title: '',
      link: '',
      uploading: false,
    };
  },
  methods: {
    async handleSubmit(e) {
      e.preventDefault();
      if (this.checkFields()) {
        try {
          this.uploading = true;

          const formData = this.createFormData();
          await this.$http.post('/partners', formData);

          this.$message.success('Parceiro adicionado com sucesso.');

          this.clearFields();
          this.uploading = false;
        } catch (error) {
          this.uploading = false;
          this.$message.error('Ocorreu um erro ao tentar adicionar o parceiro. Tente novamente mais tarde.');
        }
      } else {
        this.$message.error('Por favor preencha todos os dados obrigatórios!');
      }
    },
    checkFields() {
      return this.title && this.checkFileList();
    },
    createFormData() {
      const formData = new FormData();

      formData.append('image', this.fileList[0]);
      formData.append('name', this.title);

      if (this.link) {
        formData.append('link', this.link);
      }

      return formData;
    },
    clearFields() {
      this.fileList = [];
      this.title = '';
      this.link = '';
    },
  },
};
</script>

<style lang="stylus" scoped>
.submit-button
  float right
</style>
